## ros-noetic-mvsim 0.5.2

=== modules/comms/CMakeLists.txt ===
set(MODULE_NAME "comms")
project(mvsim-${MODULE_NAME} LANGUAGES CXX VERSION ${MVSIM_VERSION})

file(GLOB Comms_SRCS
	"${CMAKE_CURRENT_SOURCE_DIR}/src/Comms/*.cpp"
	"${CMAKE_CURRENT_SOURCE_DIR}/include/mvsim/Comms/*.h"
)

# Declare the target (a library)
add_library(${PROJECT_NAME}
	${Comms_SRCS}
)

source_group(Comms FILES ${Comms_SRCS})

set(PACKAGE_DEPENDENCIES
  mrpt-system
  mrpt-io
  mrpt-serialization
  mvsim-msgs
  )
mvsim_common_target_settings(${MODULE_NAME})

target_link_libraries(${PROJECT_NAME}
 PRIVATE
	${CMAKE_THREAD_LIBS_INIT}
	${ZeroMQ_LIBRARY}
 PUBLIC
	${Protobuf_LIBRARIES}
	mrpt::system
	mrpt::io
	mrpt::serialization
	mvsim::msgs
)

# =========== Python wrapper ==================
if (MVSIM_WITH_PYTHON)
  # Different versions of pybind11 required different generated-sources:
  string(SUBSTRING ${pybind11_VERSION} 0 3 PYBIND11_MM_VERSION)
  #message(STATUS "PYBIND11_MM_VERSION: ${PYBIND11_MM_VERSION}")

  set(PY_SRCS_DIR ${CMAKE_CURRENT_LIST_DIR}/python/generated-sources-pybind${PYBIND11_MM_VERSION})

  if (NOT EXISTS ${PY_SRCS_DIR})
	message(WARNING "Skipping python wrapper due to missing wrapper C++ files for especific pybind11 version ${PYBIND11_MM_VERSION}: expected directory '${PY_SRCS_DIR}'")
  else()
	file(GLOB_RECURSE PY_SRCS ${PY_SRCS_DIR}/*.cpp)

	pybind11_add_module(pymvsim_${MODULE_NAME}
		${PY_SRCS}
		)
	target_link_libraries(pymvsim_${MODULE_NAME} PUBLIC ${PROJECT_NAME})

	# Python files:
	file(MAKE_DIRECTORY ${MVSIM_PYTHON_BUILD_DIRECTORY}/mvsim_${MODULE_NAME}/)
	add_custom_command(TARGET pymvsim_${MODULE_NAME} POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:pymvsim_${MODULE_NAME}>
		${MVSIM_PYTHON_BUILD_DIRECTORY}/mvsim_${MODULE_NAME}/
	)
	file(WRITE ${MVSIM_PYTHON_BUILD_DIRECTORY}/mvsim_${MODULE_NAME}/__init__.py
		"from . import *")
  endif()

endif()

=== debian/changelog ===
ros-noetic-mvsim (0.5.2-1buster) buster; urgency=high

  * FIX build farm errors in armhf builds
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Thu, 26 Jan 2023 23:00:00 -0000

ros-noetic-mvsim (0.5.1-1buster) buster; urgency=high

  * FIX: Stuck unit test runs in armhf build farms
  * Add demo with a large number of robots (100) in a simple setup
  * Support <for> loops in world definition files
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Wed, 25 Jan 2023 23:00:00 -0000

ros-noetic-mvsim (0.5.0-1buster) buster; urgency=high

  * New warehouse demo world file, including ros2 launch.
  * New feature: download models from remote servers.
  * Add 3D Lidar sensor.
  * Add support for headless simulations (mvsim launch --headless), suitable for running inside docker containers
  * New world element: vertical planes.
  * Add <for /> loops in XML world files
  * Support for formulas in XML files via  exprtk expressions
  * Fix naming convention; fix warnings
  * Move to clang-format-11
  * More consistent class member naming convention
  * Add simple Velodyne sensor DAE model
  * Add wget as build and runtime dep
  * PubSub system: Implemented the feature to notify subscribed clients about a new publisher for a topic
  * New 3D model: pioneer3
  * ROS: Add build and test dep python3-protobuf
  * Added unit tests
  * mvsim cli: add the --realtime-factor flag
  * more topic echo types
  * publish 2D lidar observations as custom protobuf msgs too
  * Add new protobuf msg type ObservationLidar2D.proto
  * add shutdown service
  * Fixed Python topic subscription and parsing
  * avoid potential crash during shutdown
  * FIX: Timelogger verbosity level is now copied from the main World object.
  * BUGFIX: Lidar sensors with ignore_parent_body=true should neither see the wheels
  * Tune PID parameters of examples
  * Refactoring and simplification of mutexes
  * cache GetServiceInfoRequest() calls (more efficient service calls in comms::Client)
  * factorize World services into its own .cpp file for clarity
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Sun, 08 Jan 2023 23:00:00 -0000

ros-noetic-mvsim (0.4.3-1buster) buster; urgency=high

  * add names to gl objects (useful to debug)
  * configurable gui open timeout
  * GUI: new button Editor->Export 3Dscene file
  * Add a warning if using a physics timestep is incompatible with the sensor periods
  * FIX: more accurate simulation of timesteps; more mutexes
  * automatic determination of timestep; FIX bug: constant offset in simul time
  * fix FBO api for mrpt 2.5.6
  * fix build against mrpt 2.5.6; fix infinite loop while hitting quit button
  * refactor TCLAP objects to avoid global object initialization fiasco crashes
  * handle old and new versions of tf_geometry_msgs
  * mvsim cli new command: topic hz
  * Fix ROS2 obsolete header
  * fix build for u18.04
  * fix for older zmq versions
  * fix newest zmq deprecated warnings
  * FIX: DAE file error to load on newer version of assimp
  * provide cmake config types for gcc sanitizers
  * fix zmq API in bionic
  * avoid zmq_message_t ctor; more parallel threads for ZMQ
  * make the get_pose() service to answer immediately without needing to acquire the main simulation mutex
  * fix escaping
  * more portable makefile comparison for libbox2d version
  * d/rules: auto detection of system libbox2d version
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Sun, 13 Nov 2022 23:00:00 -0000

ros-noetic-mvsim (0.4.2-1buster) buster; urgency=high

  * Disable Python wrappers for python <3.8
  * Honor DESTDIR when building and installing
  * Honor cli-provided PYTHON_INSTALL_DIRECTORY via cmake flags
  * Fix protobuf-generated broken Python3 imports (using protoletariat)
  * Add new WorldElement type: pointcloud
  * Add Python3 example for teleop twist
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Tue, 18 Oct 2022 22:00:00 -0000

ros-noetic-mvsim (0.4.1-1buster) buster; urgency=high

  * Add more documentation, demo files, and screenshots
  * Support animations from keyframe list for blocks and vehicles
  * Refactor common xml params in Simulable interface
  * Support PARENT_NAME usage in sensor definition files; add "<publish>" tags to tutorial sensors
  * 2D lidar sensor: new XML parameter maxRange
  * change threshold to decimate sensors preview subwindows
  * BUGFIX: Uninitialized quaternion in rviz marker (Closes #14 <https://github.com/MRPT/mvsim/issues/14>)
  * Allow expressions in include tags
  * Expose more lidar params in its XML
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Wed, 12 Oct 2022 22:00:00 -0000

ros-noetic-mvsim (0.4.0-1buster) buster; urgency=high

  * Major new release with tons of new features.
  * New sensors: RGB, depth, RGB+D cameras
  * Support for ROS1 and ROS2.
  * Sensors now can have 3D models.
  * New GUI controls to customize visualization.
  * New 3 and 4 wheels differential kinematic models.
  * Allow "include"s in XML files.
  * Add 3D Jackal robot model.
  * ROS nodes: publishers in parallel thread
  * mvsim-cli new flag to enable full profiling
  * Use new nanogui feature to limit GUI refresh rate
  * Fix running faster than real-time
  * More consistent timestamping of simulated sensors
  * mvsim now shows program version info
  * get_pose() service now also gets twist
  * Fix elevation maps
  * pybind11 per-version directory
  * Remove trailing '/' in tf frame names for consistency with modern conventions.
  * Rename COPYING -> LICENSE
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Mon, 26 Sep 2022 22:00:00 -0000

ros-noetic-mvsim (0.3.2-1buster) buster; urgency=high

  * Install models/ subdirectory too
  * Changes towards building for both ros1 & ros2


=== debian/control ===
Source: ros-noetic-mvsim
Section: misc
Priority: optional
Maintainer: Jose-Luis Blanco-Claraco <jlblanco@ual.es>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libbox2d-dev, libgtest-dev <!nocheck>, libprotobuf-dev, libprotoc-dev, libzmq3-dev, protobuf-compiler, pybind11-dev, python3-protobuf, python3-venv, ros-noetic-catkin, ros-noetic-dynamic-reconfigure, ros-noetic-mrpt2, ros-noetic-nav-msgs, ros-noetic-ros-environment, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-visualization-msgs, unzip, wget
Homepage: https://wiki.ros.org/mvsim
Standards-Version: 3.9.2

Package: ros-noetic-mvsim
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libbox2d-dev, libprotobuf-dev, libprotoc-dev, libzmq3-dev, protobuf-compiler, pybind11-dev, python3-protobuf, python3-venv, ros-noetic-dynamic-reconfigure, ros-noetic-mrpt2, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-visualization-msgs, unzip, wget
Description: A lightweight multivehicle simulation framework.

## ros-noetic-mvsim 0.8.1

=== docs/requirements.txt ===
sphinx>=4.3.0
sphinx_rtd_theme>=0.5.1
sphinx_design
sphinxcontrib-bibtex

=== modules/CMakeLists.txt ===
project(libmvsim LANGUAGES CXX VERSION ${MVSIM_VERSION})

include(CMakePackageConfigHelpers)

# ========================== Dependencies ====================================
# It must be at the same directory than protobuf_generate_cpp()
option(MVSIM_WITH_PROTOBUF "Use protobuf for communications" ON)

if (MVSIM_WITH_PROTOBUF)
	find_package(Protobuf)
	if (Protobuf_FOUND)
		#
	else()
		set(MVSIM_WITH_PROTOBUF OFF CACHE BOOL "Use protobuf for communications" FORCE)
	endif()
endif()

option(MVSIM_WITH_ZMQ "Use ZMQ for communications" ON)

if (MVSIM_WITH_ZMQ)
	find_package(PkgConfig)
	pkg_check_modules(PC_ZeroMQ QUIET zmq)

	# use the hint from above to find where 'zmq.hpp' is located
	find_path(ZeroMQ_INCLUDE_DIR
			NAMES zmq.hpp
			PATHS ${PC_ZeroMQ_INCLUDE_DIRS}
			)

	# use the hint from about to find the location of libzmq
	find_library(ZeroMQ_LIBRARY
			NAMES zmq
			PATHS ${PC_ZeroMQ_LIBRARY_DIRS}
			)

	if ($ENV{VERBOSE})
		message(STATUS "ZeroMQ_LIBRARY: ${ZeroMQ_LIBRARY}")
		message(STATUS "ZeroMQ_INCLUDE_DIR: ${ZeroMQ_INCLUDE_DIR}")
	endif()

	if (ZeroMQ_LIBRARY AND ZeroMQ_INCLUDE_DIR)
		#
	else()
		set(MVSIM_WITH_ZMQ OFF CACHE BOOL "Use ZMQ for communications" FORCE)
	endif()
endif()

option(MVSIM_WITH_PYTHON "Build python wrappers" ON)
if (MVSIM_WITH_PYTHON AND (${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang"))
	set(MVSIM_WITH_PYTHON OFF CACHE BOOL "Build python wrappers" FORCE)
	message(STATUS "*WARNING* Disabling Python wrappers: not supported if built using clang (it leads to pybind11-generated code errors)")
endif()

if (MVSIM_WITH_PYTHON)
	if(NOT ${CMAKE_VERSION} VERSION_LESS "3.12.0")
		find_package(Python3 COMPONENTS Interpreter Development)
	else()
		# When cmake 3.12 is available everywhere, delete this branch of the if()
		find_program(Python3_EXECUTABLE NAMES python3)
		set(Python3_VERSION_MAJOR ${Python_VERSION_MAJOR})
		set(Python3_VERSION_MINOR ${Python_VERSION_MINOR})
	endif()
endif()

if (MVSIM_WITH_PYTHON AND ("${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR}" VERSION_LESS "3.8"))
	set(MVSIM_WITH_PYTHON OFF CACHE BOOL "Build python wrappers" FORCE)
	message(STATUS "*WARNING* Disabling Python wrappers: We require python >=3.8, but ${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR} was detected.")
endif()

if (MVSIM_WITH_PYTHON)
  # Enforce using python3:
  set(Python_ADDITIONAL_VERSIONS ${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR})
  set(PYBIND11_PYTHON_VERSION ${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR})
  find_package(pybind11 CONFIG)
  
  # The PYTHON build dir must be exactly at the same level than the root binary dir
  # in order for the different build tools (debuild,...) pass the correct relative 
  # path where to install the built python packages (e.g. under <build>/debian/tmp )
  set(MVSIM_PYTHON_BUILD_DIRECTORY ${mvsim_BINARY_DIR})

  if (pybind11_FOUND AND pybind11_VERSION VERSION_LESS 2.2)
	message(STATUS "Warning: Disabling Python bindings since pybind11 >=2.2 is required but only found version ${pybind11_VERSION}")
	set(MVSIM_WITH_PYTHON OFF CACHE BOOL "Build python wrappers" FORCE)
	set(pybind11_FOUND OFF)
  endif()

  if (NOT pybind11_FOUND)
	  set(MVSIM_WITH_PYTHON OFF CACHE BOOL "Build python wrappers" FORCE)
  endif()
endif()


# ========================== Functions ====================================

function(mvsim_common_target_settings MODULENAME_)
  set(TARGETNAME_ "mvsim-${MODULENAME_}")

  # To make code portable between using directly the mvsim source tree, or
  # importing exported cmake targets:
  add_library(mvsim::${MODULENAME_}  ALIAS ${TARGETNAME_})

  if (${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	  target_compile_options(${TARGETNAME_} PRIVATE
		  -Wall -pedantic
		  -Wsuggest-override
		  -Werror=return-type
		  -Wshadow
		  # -Werror=suggest-override # Removed for protobuf headers in u18.04
	  )

	  if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
		  target_compile_options(${TARGETNAME_} PRIVATE
			  "-O3"
		  )
	  endif()
  endif()

  if(MSVC)
	  target_compile_definitions(${TARGETNAME_} PRIVATE
		  _CRT_SECURE_NO_WARNINGS
	  )
	  target_compile_options(${TARGETNAME_} PRIVATE
		  /wd4275
		  /wd4251
	  )
  endif()

  set_target_properties(
	${TARGETNAME_}
  PROPERTIES
	SOVERSION ${PROJECT_VERSION}
	VERSION ${PROJECT_VERSION}
	ARCHIVE_OUTPUT_DIRECTORY "lib"
	LIBRARY_OUTPUT_DIRECTORY "lib"
	WINDOWS_EXPORT_ALL_SYMBOLS ON
  )

  if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/include)
      target_include_directories(${TARGETNAME_}
          PUBLIC
          $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
          $<INSTALL_INTERFACE:include>
          )
  endif()

  target_include_directories(${TARGETNAME_}
	  PRIVATE
		  ${CMAKE_CURRENT_SOURCE_DIR}/src
		  ${ZeroMQ_INCLUDE_DIR}
  )

  if (MVSIM_WITH_PROTOBUF)
    target_compile_definitions(${TARGETNAME_} PUBLIC MVSIM_HAS_PROTOBUF)
  endif()

  if (MVSIM_WITH_ZMQ)
    target_compile_definitions(${TARGETNAME_} PUBLIC MVSIM_HAS_ZMQ)
  endif()

  # ==== Install & export target ========
  install(TARGETS	${TARGETNAME_}
		  EXPORT 	${TARGETNAME_}-targets
		  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
  if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/include)
    install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
  endif()

  install(EXPORT ${TARGETNAME_}-targets
	  FILE ${TARGETNAME_}-targets.cmake
	  NAMESPACE mvsim::
	  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${TARGETNAME_}
  )
  export(
	TARGETS ${TARGETNAME_}
	FILE "${CMAKE_BINARY_DIR}/cmake/${TARGETNAME_}-targets.cmake"
	NAMESPACE mvsim::
  )

  configure_package_config_file(
	  ${mvsim_SOURCE_DIR}/cmake/mvsim-config.cmake.in
	  ${CMAKE_BINARY_DIR}/cmake/${TARGETNAME_}-config.cmake
	  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${TARGETNAME_}
  )

  write_basic_package_version_file(
	  ${CMAKE_BINARY_DIR}/cmake/${TARGETNAME_}-config-version.cmake
	  VERSION ${PROJECT_VERSION}
	  COMPATIBILITY AnyNewerVersion
  )

  install(
	  FILES
		  ${CMAKE_BINARY_DIR}/cmake/${TARGETNAME_}-config.cmake
		  ${CMAKE_BINARY_DIR}/cmake/${TARGETNAME_}-config-version.cmake
	  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${TARGETNAME_}
  )
endfunction()


# ========================== Targets ====================================
add_subdirectory(simulator)

if (MVSIM_WITH_PROTOBUF)
  add_subdirectory(comms)
  add_subdirectory(msgs)
endif()

# From: https://github.com/ament/ament_cmake/blob/rolling/ament_cmake_python/ament_cmake_python-extras.cmake
macro(mvsim_ament_cmake_python_get_python_install_dir)
  if(NOT DEFINED PYTHON_INSTALL_DIR)
    # avoid storing backslash in cached variable since CMake will interpret it as escape character
    set(_python_code
      "import os"
      "import sysconfig"
      "print(os.path.relpath(sysconfig.get_path('purelib', vars={'base': '${CMAKE_INSTALL_PREFIX}'}), start='${CMAKE_INSTALL_PREFIX}').replace(os.sep, '/'))"
    )
    # JL Was: get_executable_path(_python_interpreter Python3::Interpreter CONFIGURE)
	set(_python_interpreter ${Python3_EXECUTABLE})
    execute_process(
      COMMAND
      "${_python_interpreter}"
      "-c"
      "${_python_code}"
      OUTPUT_VARIABLE _output
      RESULT_VARIABLE _result
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    if(NOT _result EQUAL 0)
      message(FATAL_ERROR
        "execute_process(${_python_interpreter} -c '${_python_code}') returned "
        "error code ${_result}")
    endif()

    set(PYTHON_INSTALL_DIR
      "${_output}"
      CACHE INTERNAL
      "The directory for Python library installation. This needs to be in PYTHONPATH when 'setup.py install' is called.")
  endif()
endmacro()

# ========================== Install Python libs ==========================
if (pybind11_FOUND)
  #set(MVSIM_PYTHON_VERSION "${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR}"
	#    CACHE STRING "The version of Python to build MVSIM wrapper against."
	#    FORCE)

	# Generate setup.py.
	configure_file(${mvsim_SOURCE_DIR}/modules/setup.py.in
		${MVSIM_PYTHON_BUILD_DIRECTORY}/setup.py)

	install(
	FILES
	  ${PROTO_PY_FILES}
	DESTINATION
	  ${CMAKE_INSTALL_INCLUDEDIR}/mvsim/mvsim-msgs/
	)

	if (NOT DEFINED PYTHON_INSTALL_DIRECTORY)
		set(PYTHON_INSTALL_DIRECTORY ${CMAKE_INSTALL_PREFIX} CACHE PATH "Install prefix for python modules with 'make python-install'")
	endif()

	mvsim_ament_cmake_python_get_python_install_dir() # Gets PYTHON_INSTALL_DIR

	# We need to do the install via a script run during "make install" so we can 
	# catch the variable DESTDIR, used in debian builds:
	configure_file(
		${mvsim_SOURCE_DIR}/cmake/install-python.cmake.in
		${mvsim_BINARY_DIR}/install-python.cmake
		@ONLY
	)

	add_custom_target(python-install
			COMMAND ${CMAKE_COMMAND} -P ${mvsim_BINARY_DIR}/install-python.cmake
			DEPENDS mvsim-msgs pymvsim_comms
			COMMENT "Running 'python-install'")
endif()

# ========================== Show results ====================================
message(STATUS "----- Configured libmvsim (version ${PROJECT_VERSION}) ------")
message(STATUS "MRPT version   : ${mrpt-maps_VERSION}")
message(STATUS "BUILD_FOR_ROS  : ${BUILD_FOR_ROS} (ROS_VERSION: " $ENV{ROS_VERSION} ")")
if (DETECTED_ROS1)
	message(STATUS "  - catkin [req]              : ${catkin_FOUND}")
	message(STATUS "  - dynamic_reconfigure [opt] : ${dynamic_reconfigure_FOUND}")
elseif(DETECTED_ROS2)
	message(STATUS "  - rclcpp [req]              : ${rclcpp_FOUND}")
endif()

message(STATUS "libbox2d                 : ${box2d_VERSION}")
message(STATUS "Protobuf                 : ${MVSIM_WITH_PROTOBUF} ${Protobuf_VERSION}")
message(STATUS "ZeroMQ                   : ${MVSIM_WITH_ZMQ} ${ZeroMQ_VERSION}")
message(STATUS "Python wrappers          : ${MVSIM_WITH_PYTHON} (pybind11: ${pybind11_VERSION})")
message(STATUS "Python interp            : ${Python3_EXECUTABLE}")
message(STATUS "CMAKE_SYSTEM_PROCESSOR   : ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "CMAKE_SYSTEM_NAME        : ${CMAKE_SYSTEM_NAME}")
message(STATUS "CMAKE_SYSTEM_VERSION     : ${CMAKE_SYSTEM_VERSION}")
if ($ENV{VERBOSE})
	message(STATUS "CMAKE_INSTALL_PREFIX     : ${CMAKE_INSTALL_PREFIX}")
	message(STATUS "DESTDIR                  : ${DESTDIR}")
	message(STATUS "Python3_SITELIB          : ${Python3_SITELIB}")
	message(STATUS "PYTHON_INSTALL_DIRECTORY : ${PYTHON_INSTALL_DIRECTORY}")
	message(STATUS "PYTHON_INSTALL_DIR       : ${PYTHON_INSTALL_DIR}")
endif()
message(STATUS "")

=== modules/simulator/CMakeLists.txt ===
set(MODULE_NAME "simulator")
project(mvsim-${MODULE_NAME} LANGUAGES CXX VERSION ${MVSIM_VERSION})

file(GLOB ROOT_SRCS
	"${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp"
	"${CMAKE_CURRENT_SOURCE_DIR}/src/*.h"
	"${CMAKE_CURRENT_SOURCE_DIR}/include/mvsim/*.h"
)
file(GLOB Sensors_SRCS
	"${CMAKE_CURRENT_SOURCE_DIR}/src/Sensors/*.cpp"
	"${CMAKE_CURRENT_SOURCE_DIR}/include/mvsim/Sensors/*.h"
)
file(GLOB Friction_SRCS
	"${CMAKE_CURRENT_SOURCE_DIR}/src/FrictionModels/*.cpp"
	"${CMAKE_CURRENT_SOURCE_DIR}/include/mvsim/FrictionModels/*.h"
)
file(GLOB VehicleDynamics_SRCS
	"${CMAKE_CURRENT_SOURCE_DIR}/src/VehicleDynamics/*.cpp"
	"${CMAKE_CURRENT_SOURCE_DIR}/include/mvsim/VehicleDynamics/*.h"
)
file(GLOB WorldElements_SRCS
	"${CMAKE_CURRENT_SOURCE_DIR}/src/WorldElements/*.cpp"
	"${CMAKE_CURRENT_SOURCE_DIR}/include/mvsim/WorldElements/*.h"
)

# Declare the target (a library)
add_library(${PROJECT_NAME}
	${ROOT_SRCS}
	${Sensors_SRCS}
	${Friction_SRCS}
	${VehicleDynamics_SRCS}
	${WorldElements_SRCS}
)
add_library(mvsim::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

mvsim_set_target_build_options(${PROJECT_NAME})

source_group(Main FILES ${ROOT_SRCS})
source_group(Sensors FILES ${Sensors_SRCS})
source_group(Friction FILES ${Friction_SRCS})
source_group(VehicleDynamics FILES ${VehicleDynamics_SRCS})
source_group(WorldElements FILES ${WorldElements_SRCS})

set(PACKAGE_DEPENDENCIES
  mrpt-maps
  mrpt-gui
  mvsim-comms
  box2d
  )
mvsim_common_target_settings(${MODULE_NAME})


target_link_libraries(${PROJECT_NAME}
 PRIVATE
	mvsim::msgs
#	${CMAKE_THREAD_LIBS_INIT}
#	${Protobuf_LIBRARIES}
#	${ZeroMQ_LIBRARY}
PUBLIC
	mrpt::obs
	mrpt::opengl
	mrpt::maps
	mrpt::gui
	mvsim::comms
	${BOX2D_LIBRARIES}
)


target_include_directories(${PROJECT_NAME}
	SYSTEM PUBLIC
		$<BUILD_INTERFACE:${mvsim_SOURCE_DIR}/externals/rapidxml>
)

=== debian/changelog ===
ros-noetic-mvsim (0.8.1-1focal) focal; urgency=high

  * Move the rawlog-generation option to the World global options instead of sensor-wise.
  * Create CITATION.cff
  * helios 32fov70 sensor.xml: Fix missing MVSIM_CURRENT_FILE_DIRECTORY tag
  * Fix crash in edge case with world file path in the current directory
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Wed, 06 Sep 2023 22:00:00 -0000

ros-noetic-mvsim (0.8.0-1focal) focal; urgency=high

  * Recursive "include"s are now possible.
  * All vehicle and sensor definitions are now exposed in public directory 'definitions' and are safe to be included from user worlds
  * ROS warehouse demos: fix wrong camera topicn ame in rviz
  * Add missing ROS 2 launch demo for greenhouse world
  * Add new variable: MVSIM_CURRENT_FILE_DIRECTORY
  * BUGFIX: In parseVars() in the XML parser
  * Debugging feature: MVSIM_VERBOSE_PARSE now also traces <variable> definitions
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Fri, 01 Sep 2023 22:00:00 -0000

ros-noetic-mvsim (0.7.4-1focal) focal; urgency=high

  * Add new LIDAR 3D models: Helios 32.
  * Removed LIDAR3D fbo_nrows parameter, automatically computed now from geometry solutions.
  * More optimal simulation of asymmetric 3D lidars.
  * Progress with RTD documentation.
  * Add proper bibliography; fix all docs warnings
  * ROS 2 warehouse demo: show 2D lidar in RVIZ too; add headless launch argument
  * New GUI editor feature: move sensor poses
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Tue, 29 Aug 2023 22:00:00 -0000

ros-noetic-mvsim (0.7.3-1focal) focal; urgency=high

  * Update python module install method to pip (fixes deprecation)
  * Improved docs
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Tue, 22 Aug 2023 22:00:00 -0000

ros-noetic-mvsim (0.7.2-1focal) focal; urgency=high

  * Joystick driving: added support for direct driving the vehicles with a joystick.
  * Fix rviz for ros1 demo
  * Better docs and more modern RST style.
  * More shadow tuning parameters.
  * IMU sensor now reads real vehicle linear acceleration.
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Fri, 11 Aug 2023 22:00:00 -0000

ros-noetic-mvsim (0.7.1-1focal) focal; urgency=high

  * ROS node: fix potential race condition creating publisher for highrate sensors
  * Add IMU sensors
  * New property <visual enabled='true|false'>
  * lidar2d xml: add option "sensor_custom_visual"
  * FIX: Crash if launching an empty world
  * Trigger an error if using use_sim_time to avoid mistakes
  * Add new (fake) controller: twist_ideal
  * ROS 1: don't enforce /use_sim_time
  * Add ROS 2 launch for the 2-robot demo
  * Fix cmake leftover
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Sat, 10 Jun 2023 22:00:00 -0000

ros-noetic-mvsim (0.7.0-1focal) focal; urgency=high

  * Automatic detection of collision shapes
  * Add turtlebot world demo
  * Rely on custom build of Box2D to increase the maximum polygon vertices count (8 to 12).
  * fix inconsistent use_sim_time value for ROS 2 (it should be false)
  * Expose shadow rendering parameters in the XML world file
  * Abort simulation on exceptions in headless mode too
  * ROS 1 and 2 nodes now quit cleanly and quickly with SIGINT
  * Add ros2 launch for turtlebot world demo
  * Automatic determination of zmin/zmax for blocks if not explicitly set in XML
  * Force c++17 for python module
  * Exit simulator on exceptions in GUI-related threads
  * More automated testing
  * Add unit tests in C++ too
  * Refactor collision shape determination
  * New UI checkbox: show collision shapes
  * Allow simply geometry definitions without external 3D model file for "blocks"
  * Light options are now under <light> XML tag.
  * Largest default physics simulation timestep changed from 50ms to 5ms
  * GUI: change light direction
  * Add GUI checkbox to enable/disable shadows
  * Add rplidar A2 sensor model
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Thu, 20 Apr 2023 22:00:00 -0000

ros-noetic-mvsim (0.6.1-1focal) focal; urgency=high

  * New XML parameters to enable and tune shadowmap generation
  * Use finer timestep for prevent wrong simulation of ramp sliding
  * Fix code notation
  * Temporary workaround to GH CI problem
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Fri, 03 Mar 2023 23:00:00 -0000

ros-noetic-mvsim (0.6.0-1focal) focal; urgency=high

  * Support for SkyBox rendering (requires MRPT >=2.7.0)
  * More camera options in world.xml files (initial azimuth, elevation, etc.)
  * Terrain elevation models now support repeated textures (requires MRPT >=2.7.0)
  * Faster 3D Lidar rendering (Requires MRPT >=2.7.0)
  * Add Ouster OS1 sensor file
  * Fix default friction coefficients; draw motor torques too
  * More accurate Velodyne simulation based on sensor_rpm parameter
  * Clearer code and code style conventions
  * Add "<static>" XML tag for large, static world objects
  * Support for XML tag <if ...>
  * Refactor xml parser as a registry of tag->function
  * Examples renamed for conciseness: 'mvsim_demo_*' to 'demo_*'
  * Added a "greenhouse" example world
  * Wheels: allow linked-yaw-objects in vehicle viz
  * Support several <visual> tags in custom visualization models
  * pybind11 sources simplification.
    Simplify into one single source tree with conditional compilation for different pybind versions.
  * Emit clearer warnings and earlier detection of wrong bounding boxes
  * Add reference to (preprint) paper
  * Controllers: Made threadsafe
  * Contributors: Fernando Cañadas, Jose Luis Blanco-Claraco
  * BUGFIX: program did not quit if using a non-existing launch file.
  * BUGFIX: unneeded friction coefficient for chassis body


=== debian/control ===
Source: ros-noetic-mvsim
Section: misc
Priority: optional
Maintainer: Jose-Luis Blanco-Claraco <jlblanco@ual.es>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libgtest-dev <!nocheck>, libprotobuf-dev, libprotoc-dev, libzmq3-dev, protobuf-compiler, pybind11-dev, python3-protobuf, python3-venv, ros-noetic-catkin, ros-noetic-dynamic-reconfigure, ros-noetic-mrpt2, ros-noetic-nav-msgs, ros-noetic-ros-environment, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-visualization-msgs, unzip, wget
Homepage: https://wiki.ros.org/mvsim
Standards-Version: 3.9.2

Package: ros-noetic-mvsim
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libprotobuf-dev, libprotoc-dev, libzmq3-dev, protobuf-compiler, pybind11-dev, python3-protobuf, python3-venv, ros-noetic-dynamic-reconfigure, ros-noetic-mrpt2, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-visualization-msgs, unzip, wget
Description: A lightweight multivehicle simulation framework.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-mvsim//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
